/**
 * Threat Intelligence API
 * Use the Threat Intelligence API to view indicators of compromise and related items. For more information, see [Overview of Threat Intelligence](/Content/ThreatIntelligence/Concepts/threatintelligenceoverview.htm).
 * OpenAPI spec version: 20210831
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The visibility level associated with data and an associated TLP (https://www.cisa.gov/tlp) level.
 */
export interface DataVisibility {
    /**
     * The name of the visibility level.
     */
    "name": string;
    /**
     * The Traffic Light Protocol (TLP) name of the visibility level.
     */
    "tlpName": DataVisibility.TlpName;
}
export declare namespace DataVisibility {
    enum TlpName {
        TlpInternalAudit = "TLP_INTERNAL_AUDIT",
        TlpWhite = "TLP_WHITE",
        TlpGreen = "TLP_GREEN",
        TlpAmber = "TLP_AMBER",
        TlpRed = "TLP_RED",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: DataVisibility): object;
    function getDeserializedJsonObj(obj: DataVisibility): object;
}
